mouse_handler dw 0
mouse_interrupt db 0
mouseCursor 	db 10000b
		db 11000b
		db 11100b
		db 11110b
		db 10100b
		db 00010b
MousePosition_y db 32
MousePosition_x db 64
Button_Counter dw 0
Button_Table db 80 dup(0) ;4x byte for position, 1xByte for "What", 1x Byte reserved, 1x Word for ID --> 10 Records


MouseEnabled    db 0	;Always leave disabled till graphics initialized!


_drawMouse proc
	CMP byte ptr CS:[mouseEnabled],NO
	JE @@do_nothing
	PUSH AX DX
	MOV DX,word ptr CS:[mouseposition_y]
	MOV AL,255
	MOV AH,clInverse
	call _SetGraphicChar
	POP DX AX
	@@do_nothing: ret
endp

_Keyboard_Mouse proc
	TESTKey KEY_EXE
	JE @@run
	call _DrawMouse

	PUSH AX
	MOV AX,word ptr CS:[MousePosition_y]
	TESTKey Key_Left
	JE @@left
	TESTKey Key_Right
	JE @@right
	TestKey Key_Up
	JE @@up
	TESTKey Key_down
	JE @@down
	call _DrawMouse
	POP AX
	ret
	@@left:
		DEC AH
		JMP @@test_end
	@@right:
		INC AH
		JMP @@test_end
	@@up:
		DEC AL
		JMP @@test_end
	@@down:
		INC AL
		JMP @@test_end
	@@test_end:
		CMP AH,-1
		JE @@ah0
		CMP AH,125
		JE @@ah127
		CMP AL,-1
		JE @@al0
		CMP AL,64
		JE @@al63
	@@do:
		MOV word ptr CS:[MousePosition_y],AX
		POP AX
		call _DrawMouse
	ret
	@@run:
	MOV byte ptr CS:[Mouse_Interrupt],1
	ret
	@@ah0:	MOV AH,0
		JMP @@test_end
	@@ah127:MOV AH,124
		JMP @@test_end
	@@al63: MOV AL,63
		JMP @@test_end
	@@al0:	MOV AL,0
		JMP @@test_end
endp